package uk.ac.cardiff.booking.api.bookings;

import java.time.LocalDateTime;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;

@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
@ToString
@Entity
public class Booking {
  
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Integer id;
  
  @Column(name = "student_number")
  private String studentNumber;

  @Column(name = "tutor_id")
  private Integer tutorId;

  @Column(name = "student_name")
  private String studentName;

  @Column(name = "tutor_name")
  private String tutorName;

  @Column(name = "booking_start")
  private LocalDateTime bookingStart;

  @Column(name = "booking_end")
  private LocalDateTime bookingEnd;

  @Column(name = "transcript_id")
  private Integer transcriptId;

  @Column(name = "module_code")
  private String moduleCode;

  @Column(name = "coursework_id")
  private Integer courseworkId;
}