package uk.ac.cardiff.booking.api.bookings;

import java.time.LocalDateTime;
import java.util.List;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;

public interface BookingRepository extends CrudRepository<Booking, Integer> {
  
  List<Booking> findByStudentNumber(String studentNumber);

  @Query(value = "FROM Booking where tutorId = ?1 and bookingStart between ?2 and ?3")
  List<Booking> findBookings(Integer tutorId, LocalDateTime startTime, LocalDateTime endTime);
}