package uk.ac.cardiff.booking.api.bookings;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class BookingService {
  
  @Autowired
  private BookingRepository bookingRepo;

  /**
   * Supplies a list of bookings on a specific state for a specific tutor
   * @return
   */
  public List<Booking> getBooking(LocalDate date, Integer tutorId) {
    LocalDateTime startOfDay = date.atStartOfDay();
    LocalDateTime endOfDay = date.plusDays(1L).atStartOfDay().minusMinutes(1L);
    return bookingRepo.findBookings(tutorId, startOfDay, endOfDay);
  }
}