package uk.ac.cardiff.booking.api.bookings;

import java.net.URI;
import java.util.List;
import java.util.UUID;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import lombok.extern.slf4j.Slf4j;
import uk.ac.cardiff.booking.api.tutor.AppointmentDto;
import uk.ac.cardiff.booking.api.tutor.AppointmentService;

@RestController
@RequestMapping("/bookings")
@Slf4j
public class BookingsController {
  
  @Autowired
  private AppointmentService appointmentService;

  @PostMapping("/")
  public ResponseEntity<Booking> createBooking(@RequestBody Booking booking) {
    return ResponseEntity.created(URI.create("/bookings/123"))
            .body(null);
  }

  @GetMapping("/")
  public ResponseEntity<List<Booking>> getBookings() {
    return ResponseEntity.ok().body(null);
  }

  @GetMapping("/student/{student_id}")
  public ResponseEntity<List<AppointmentDto>> getBookingsForStudent(
      @PathVariable("student_id") String studentId, 
      @RequestHeader("auth-code") UUID authCode) {
    log.info(authCode.toString());
    List<AppointmentDto> apps = appointmentService.getAppointmentsByStudentId(studentId, authCode);
    return ResponseEntity.ok().body(apps);
  }

  @GetMapping("/{booking_id}")
  public ResponseEntity<Booking> getBooking(@PathVariable("booking_id") String bookingId) {
    return ResponseEntity.ok().body(null);
  }

  @PutMapping("/{booking_id}")
  public ResponseEntity<Booking> putBooking(@PathVariable("booking_id") String bookingId,
      @RequestBody Booking booking) {
    return ResponseEntity.noContent().build();
  }

  @DeleteMapping("/{booking_id}")
  public ResponseEntity<Booking> deleteBooking(@PathVariable("booking_id") String bookingId) {
    return ResponseEntity.noContent().build();
  }
}