package uk.ac.cardiff.booking.api.module;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;

import com.fasterxml.jackson.annotation.JsonBackReference;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import uk.ac.cardiff.booking.api.tutor.Appointment;
import uk.ac.cardiff.booking.api.tutor.Tutor;

@Getter
@Setter
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
public class Module {
  
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  @Column(name = "module_id")
  private Integer id;

  @Column(name="module_code")
  private String moduleCode;

  @Column(name="module_name")
  private String moduleName;

  @ManyToMany
  @JoinTable(
    name = "module_tutor_join", 
    joinColumns = @JoinColumn(name = "module_id"), 
    inverseJoinColumns = @JoinColumn(name = "tutor_id"))
  private Set<Tutor> tutors;

  @OneToMany(mappedBy = "module")
  @JsonBackReference("appointments")
  private Set<Appointment> appointments;
}