package uk.ac.cardiff.booking.api.transcripts;

import java.util.UUID;

import org.apache.commons.io.FilenameUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;

import io.minio.BucketExistsArgs;
import io.minio.MakeBucketArgs;
import io.minio.MinioClient;
import io.minio.PutObjectArgs;

@Component
public class FileUploader {

  @Autowired
  private MinioClient minioClient;

  public String upload(MultipartFile file) throws Exception {
    if(!minioClient.bucketExists(BucketExistsArgs.builder().bucket("transcripts").build())) {
      minioClient.makeBucket(MakeBucketArgs.builder().bucket("transcripts").build());
    }
    UUID objectId = UUID.randomUUID();
    String filename = objectId.toString() + "." + FilenameUtils.getExtension(file.getOriginalFilename());
    minioClient.putObject(PutObjectArgs.builder().bucket("transcripts").object(filename).stream(file.getInputStream(), file.getSize(), -1).build());
    return filename;
  }
}