package uk.ac.cardiff.booking.api.tutor;

import java.time.LocalDateTime;

import java.util.UUID;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;

import uk.ac.cardiff.booking.api.module.Module;
import uk.ac.cardiff.booking.api.transcripts.Transcript;

@Entity
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@ToString
public class Appointment {
  
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  @Column(name = "appointment_id")
  private Integer id;
  @Column(name = "appointment_start")
  private LocalDateTime appointmentStart;
  @Column(name = "appointment_end")
  private LocalDateTime appointmentEnd;
  @Column(name = "title")
  private String title;
  @Column(name = "student_number")
  private String studentNumber;
  @Column(name = "auth_code")
  private UUID authCode;
  @ManyToOne(fetch = FetchType.LAZY)
  @JoinColumn(name = "tutor_id")
  private Tutor tutor;
  @ManyToOne(fetch = FetchType.LAZY)
  @JoinColumn(name = "module_id")
  private Module module;
  @ManyToOne(fetch = FetchType.LAZY)
  @JoinColumn(name = "transcript_id")
  private Transcript transcript;
}