package uk.ac.cardiff.booking.api.tutor;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;

import com.fasterxml.jackson.annotation.JsonBackReference;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import uk.ac.cardiff.booking.api.module.Module;

@Getter
@Setter
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
public class Tutor {
  
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  @Column(name = "tutor_id")
  private Integer id;

  private String name;

  @ManyToMany(mappedBy = "tutors")
  @JsonBackReference("modules")
  private Set<Module> modules;

  @OneToMany(mappedBy = "tutor")
  @JsonBackReference("appointments")
  private Set<Appointment> appointments;
}