package uk.ac.cardiff.booking.api.tutor;

import java.net.URI;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/tutors")
public class TutorController {
  
  @Autowired
  private TutorRepository tutorRepo;

  @Autowired
  private TutorService tutorService;
  
  @PostMapping(value = "", 
    consumes=MediaType.APPLICATION_JSON_VALUE)
  public ResponseEntity<Tutor> createTutor(@RequestBody Tutor tutor) {
    Tutor savedTutor = tutorService.saveTutor(tutor);
    return ResponseEntity.created(URI.create("/tutor/"+savedTutor.getId())).body(savedTutor);
  }

  @GetMapping("")
  public ResponseEntity<List<Tutor>> getTutors() {
    List<Tutor> tutorList = new ArrayList<>();
    Iterator<Tutor> tutors = tutorRepo.findAll().iterator();
    while (tutors.hasNext()) {
      tutorList.add(tutors.next());
    }
    return ResponseEntity.ok().body(tutorList);
  }
}