package uk.ac.cardiff.booking.api.tutor;

import javax.transaction.Transactional;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class TutorService {

  private static final Logger LOG = LoggerFactory.getLogger(TutorService.class);
  
  @Autowired
  private TutorRepository tutorRepo;

  @Transactional
  public Tutor saveTutor(Tutor tutor) {
    LOG.info(tutor.toString());
    return tutorRepo.save(tutor);
  }

  @Transactional
  public Tutor findById(Integer tutorId) {
    return tutorRepo.findById(tutorId).orElseThrow(() -> new MissingTutorException());
  }
}