package uk.ac.cardiff.booking.api.bookings;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.ArgumentMatchers;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.mockito.junit.jupiter.MockitoExtension;

@ExtendWith(MockitoExtension.class)
public class BookingServiceTest {
  
  @InjectMocks
  private BookingService bookingService;

  @Mock
  private BookingRepository bookingRepository;

  @Test
  public void willCallRepositoryWithCorrectDateTimes() {
    LocalDate queryDate = LocalDate.of(2020, 01, 01);

    Mockito.when(bookingRepository.findBookings(ArgumentMatchers.anyInt(), ArgumentMatchers.any(LocalDateTime.class), ArgumentMatchers.any(LocalDateTime.class)))
      .thenReturn(List.of(Booking.builder().build()));
    bookingService.getBooking(queryDate, 1);

    var expectedStartTime = queryDate.atStartOfDay();
    var expectedEndTime = expectedStartTime.plusHours(23).plusMinutes(59);

    Mockito.verify(bookingRepository).findBookings(1, expectedStartTime, expectedEndTime);
  }
}