package uk.ac.cardiff.booking.api.bookings;

import java.util.List;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.InjectMocks;
import org.mockito.junit.jupiter.MockitoExtension;
import org.springframework.http.ResponseEntity;

@ExtendWith(MockitoExtension.class)
public class BookingsControllerUnitTest {

  @InjectMocks
  private BookingsController controller;

  @Test
  public void testGetListReturns200() {
    ResponseEntity<List<Booking>> bookingResponse = controller.getBookings();

    Assertions.assertEquals(200, bookingResponse.getStatusCode().value());
  }

  @Test
  public void testGetBookingReturns200() {
    ResponseEntity<Booking> bookingResponse = controller.getBooking("123");

    Assertions.assertEquals(200, bookingResponse.getStatusCode().value());
  }

  @Test
  public void testCreateBookingReturns201withLocationHeader() {
    ResponseEntity<Booking> bookingResponse = controller.createBooking(new Booking());

    Assertions.assertEquals(201, bookingResponse.getStatusCode().value());
    Assertions.assertEquals("/bookings/123", bookingResponse.getHeaders().getLocation().toString());
  }

  @Test
  public void testUpdateBookingReturns204() {
    ResponseEntity<Booking> bookingResponse = controller.putBooking("123", new Booking());

    Assertions.assertEquals(204, bookingResponse.getStatusCode().value());
  }

  @Test
  public void testDeleteBookingReturns204() {
    ResponseEntity<Booking> bookingResponse = controller.deleteBooking("123");

    Assertions.assertEquals(204, bookingResponse.getStatusCode().value());
  }
}