package uk.ac.cardiff.booking.api.bookings;

import java.time.LocalDateTime;
import java.util.List;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest;
import org.springframework.test.context.junit.jupiter.SpringExtension;


@ExtendWith(SpringExtension.class)
@DataJpaTest
public class BookingsRepositoryUnitTest {
  
  @Autowired
  private BookingRepository bookingsRepository;

  @Test
  public void willSaveBookingToDatabase() {
    Booking booking = Booking.builder()
        .moduleCode("CMT-145")
        .studentNumber("12345678")
        .build();
    Booking savedBooking = bookingsRepository.save(booking);

    Assertions.assertNotNull(savedBooking.getId());
  }

  @Test
  public void willFindBookingsByStudentNumber() {
    List<Booking> bookings = bookingsRepository.findByStudentNumber("1234561");

    Assertions.assertEquals(1, bookings.size());
  }

  @Test
  public void testGetBookingsOnDay() {
    List<Booking> bookings = bookingsRepository.findBookings(1, LocalDateTime.of(2020, 01, 01, 00, 00), LocalDateTime.of(2020, 01, 01, 11, 59));

    Assertions.assertEquals(2, bookings.size());
  }
}