package uk.ac.cardiff.booking.api.module;

import java.util.List;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import uk.ac.cardiff.booking.api.tutor.Tutor;

@ExtendWith(SpringExtension.class)
@DataJpaTest
public class ModuleCodeRepositoryTest {
  
  @Autowired
  private ModuleRepository moduleRepo;

  @Test
  public void willReturnModulesAfterSearch() {
    Module module = moduleRepo.findByModuleCode("CMT-159");

    Assertions.assertEquals("CMT-159", module.getModuleCode());
    Assertions.assertEquals("Computing with Python", module.getModuleName());
    Assertions.assertEquals(2, module.getTutors().size());
  }

  @Test
  public void willSaveAdditionalTutorToModule() {
    Module module = moduleRepo.findByModuleCode("CMT-151");
    Tutor newTutor = Tutor.builder().name("Dr Jeff").build();

    module.getTutors().add(newTutor);
    moduleRepo.save(module);

    Module testModule = moduleRepo.findById(2).get();

    Assertions.assertEquals(2, testModule.getTutors().size());
  } 
}