package uk.ac.cardiff.booking.api.tutor;

import java.util.List;
import java.util.UUID;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest;
import org.springframework.test.context.junit.jupiter.SpringExtension;

@ExtendWith(SpringExtension.class)
@DataJpaTest
public class AppointmentRepositoryTest {
 
  @Autowired
  private AppointmentRepository appointmentRepository;

  @Test
  public void willRetrieveATutorsAppointments() {
    List<Appointment> appointments = appointmentRepository.findByTutorId(1);

    Assertions.assertEquals(2, appointments.size());
  }

  @Test
  public void willRetrieveATutorsAppointmentsWithStudentNumberAndAuthCode() {
    List<Appointment> appointments = appointmentRepository.findByStudentNumberAndAuthCode("12345678",
      UUID.fromString("83920475-fa74-1e98-dc1e-578e13ee7896"));

    Assertions.assertEquals(2, appointments.size());
  }
}