document.addEventListener('DOMContentLoaded', function() {
  const urlParams = new URLSearchParams(window.location.search)
  const tutorId = urlParams.get('tutorId') || 0
  var calendarEl = document.getElementById('calendar');
  var calendar = new FullCalendar.Calendar(calendarEl, {
    timeZone: 'Europe/London',
    selectable: true,
    selectOverlap: false,
    selectConstraint: "businessHours",
    initialView: 'timeGridWeek',
    headerToolbar: { 
      right: 'timeGridWeek prev,next',
      center: "submit"
    },
    editable: true,
    businessHours: {
      daysOfWeek: [ 1, 2, 3, 4, 5 ], // Monday - Friday
      startTime: '08:00',
      endTime: '18:00',
    },
    select: function(info) {
      console.log(JSON.stringify(info))
      $('#apptStartTime').val(info.startStr);
      $('#apptEndTime').val(info.endStr);
      $(".fc-highlight").css("background", "green");
      // $.ajax({url: `/calendar/tutor/${tutorId}/appointments`, data: JSON.stringify(info), 
      //   type: "POST",
      //   contentType: "application/json",
      //   dataType: "json",
      //   error: function(xhr,status,error) {
      //     alert(status)
      //   },
      //   success: function(result){
      //     location.reload();
      //   }
      // });
    },
    eventClick : function(info) {
      if (confirm('Do you want to remove the appointment?')) {
        $('#apptStartTime').val("");
        $('#apptEndTime').val("");
        // $.ajax({url: `/calendar/tutor/${tutorId}/appointments/${info.event.id}`, data: JSON.stringify(info), 
        //   type: "DELETE",
        //   contentType: "application/json",
        //   dataType: "json",
        //   error: function(xhr,status,error) {
        //     alert(status)
        //   },
        //   success: function(result){
        //     location.reload();
        //   }
        // });
      }
    },
    customButtons: {
      submit: {
        text: 'submit',
        click:function(event, jsEvent, view){
          body = {
            startStr: $('#apptStartTime').val(),
            endStr: $('#apptEndTime').val()
          }
          $.ajax({url: `/calendar/tutor/${tutorId}/appointments`, data: JSON.stringify(body), 
            type: "POST",
            contentType: "application/json",
            dataType: "json",
            error: function(xhr,status,error) {
              alert(status)
            },
            success: function(result){
              alert("Appointment added");
              window.location.href = result.redirect
            }
          });
        }
      }
    },
    views: {
      dayGridMonth: { 
        titleFormat: { year: 'numeric', month: 'short', day: '2-digit' }
      }
    },
    eventSources: [
      `/calendar/tutor/${tutorId}/appointments`
    ]
  });
  calendar.render();
});