const express = require("express");
const fetch = require('node-fetch');
const {uuid} = require('uuidv4')
const session = require('../session/session')
const router = express.Router();

const API_HOST = process.env.API_HOST || "http://localhost";
const API_PORT = process.env.API_PORT || 8888;

router.get("/", async (req,res) => {
  sessionId = req.cookies["sessionId"]
  sess = JSON.parse(await session.getSession(sessionId))
  if (req.query.tutorId != sess.tutorId) {
    return res.redirect(`/calendar?tutorId=${sess.tutorId}`)
  }
  return res.render("staff/calendar.html")
})

router.get("/tutor/:tutorId/appointments", async (req, res) => {
  response = await fetch(`${API_HOST}:${API_PORT}/tutors/${req.params.tutorId}/appointments`)
  responseBody = await response.json()
  return res.json(responseBody)
})

router.post("/tutor/:tutorId/appointments", async (req, res) => {
  sess = JSON.parse(await session.getSession(req.cookies['sessionId']))
  var body = JSON.stringify({
    start: req.body.startStr,
    end: req.body.endStr,
    tutorId: req.params.tutorId,
    moduleCode: sess["moduleCode"],
    authCode: req.cookies['sessionId'],
    studentNumber: sess["studentId"],
    title: `${sess.studentId} - ${sess.name}`,
    transcriptId: sess["transcriptId"]
  });
  console.log(req.cookies['sessionId'])
  response = await fetch(`${API_HOST}:${API_PORT}/tutors/${req.params.tutorId}/appointments`, { method: 'POST',
    headers: {
      "Content-Type": "application/json",
      "Accept": "application/json"
    },
    body
  })
  responseBody = await response.json()
  return res.json({status: "Success", redirect: '/calendar/success'});
})

router.get("/success", async (req, res) => {
  return res.render("student/appointment_success.html", {
    authCode: req.cookies['sessionId']
  })
})

router.delete("/tutor/:tutorId/appointments/:appointmentId", async (req, res) => {
  console.log("hheheheheheheheheh")
  response = await fetch(`${API_HOST}:${API_PORT}/tutors/${req.params.tutorId}/appointments/${req.params.appointmentId}`, { method: 'DELETE'
  })
  return res.json({})
})

module.exports = router