const express = require("express");
const fetch = require('node-fetch');
const session = require("../session/session");
const router = express.Router();

const API_HOST = process.env.API_HOST || "http://localhost";
const API_PORT = process.env.API_PORT || 8888;

router.get("/", (req,res) => {
  return res.render("staff/add_module.html")
})

router.post("/", async (req,res) => {
  var body = JSON.stringify({
      moduleCode: req.body.moduleCode,
      moduleName: req.body.name
    });
  console.log(body)
  response = await fetch(`${API_HOST}:${API_PORT}/modules`, { method: 'POST',
    headers: {
      "Content-Type": "application/json",
      "Accept": "application/json"
    },
    body
  })

  console.log(await response.json())

  return res.redirect("/staff")
})

router.get("/tutors", async (req,res) => {
  modTut = await modulesAndTutors()
  console.log(modTut)
  return res.render("staff/assign_module.html", modTut)
})

modulesAndTutors = async () => {
  modulesRes = await fetch(`${API_HOST}:${API_PORT}/modules`)
  tutorsRes = await fetch(`${API_HOST}:${API_PORT}/tutors`)

  moduleResponseBody = await modulesRes.json()
  tutorResponseBody = await tutorsRes.json()

  return {
    modules: moduleResponseBody,
    tutors: tutorResponseBody
  }
}

router.post("/tutors", async (req,res) => {
  const sess = JSON.parse(await session.getSession(req.cookies["sessionId"]))
  var body = JSON.stringify({
    id: req.body.tutorId
  });
  console.log(body)
  response = await fetch(`${API_HOST}:${API_PORT}/modules/${req.body.moduleCode}/tutors`, { method: 'POST',
    headers: {
      "Content-Type": "application/json",
      "Accept": "application/json"
    },
    body
  })

  console.log(await response.json())

  return res.redirect("/staff")
})

module.exports = router