const {uuid} = require("uuidv4");
const session = require('./session')

const COOKIE = "sessionId";

cookieMiddleware = async (req, res, next) => {
  if (req.originalUrl == "/student/auth") {
    return next()
  }
  const cookie = req.cookies[COOKIE];
  if (!cookie) {
    console.log("No cookie found, creating new");
    sessionId = uuid();
    res.cookie(COOKIE, sessionId, { maxAge: 900000000, httpOnly: true });
    await session.upsertSession(sessionId, JSON.stringify({isTutor: false}));
    return res.redirect(req.originalUrl);
  }
  sess = JSON.parse(await session.getSession(cookie));
  if (!sess) {
    console.log("clearing cookie");
    res.clearCookie(COOKIE, { expires: new Date(1), path: '/' });
    return next()
  }
  console.log(`session: ${JSON.stringify(sess)}`)
  if (!sess.studentId) {
    if (req.originalUrl != "/student/new") {
      return res.redirect("/student/new")
    }
  }
  next();
};

module.exports = cookieMiddleware;