const redis = require("redis");
const asyncRedis = require("async-redis");
const client = redis.createClient(options={
  host: process.env.REDIS_HOST || "localhost",
  port: process.env.REDIS_PORT || 6379
});
const asyncRedisClient = asyncRedis.decorate(client);

asyncRedisClient.on("error", function(error) {
  console.error(error);
});

getSession = async (sessionId) => {
  try {
    decodedData = Buffer.from(await asyncRedisClient.get(sessionId), 'base64')
    return decodedData
  } catch(ex) {
    console.log(ex)
    return null
  }
}

upsertSession = async (sessionId, data) => {
  console.log(`session to save: ${data}`)
  encodedData = Buffer.from(data).toString('base64')
  console.log(`encoded data, ${sessionId}: ${encodedData}`)
  asyncRedisClient.setex(sessionId, 7776000, encodedData)
}

module.exports = { getSession, upsertSession }