package booking.frontend.pages;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.support.ui.Select;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class CalendarPage {

  @Autowired
  private WebDriver webDriver;

  public void click(String id) {
    webDriver.findElement(By.id(id)).click();
  }

  public CalendarPage inputText(String id, String message) {
    webDriver.findElement(By.id(id)).sendKeys(message);
    return this;
  }

  public CalendarPage selectOption(String id, String option) {
    new Select(webDriver.findElement(By.id(id)))
      .selectByVisibleText(option);
    return this;
  }
}