package booking.frontend.pages;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class HomePage {

  @Autowired
  private WebDriver webDriver;

  @Value("${frontend.url}")
  public String url;

  public HomePage visit() {
    webDriver.get(url);
    return this;
  }

  public void click(String id) {
    webDriver.findElement(By.id(id)).click();
  }

  public void clickLogin() {
    click("staffLogin");
  }

  public void clickBooking() {
    click("bookingNav");
  }

  public void clickExistingBooking() {
    click("existingNav");
  }
}