package booking.frontend.pages;

import static org.junit.jupiter.api.Assertions.assertTrue;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class LoginPage {

  @Autowired
  private WebDriver webDriver;

  @Value("${frontend.url}")
  private String ropsUrl;

  @Value("${frontend.username}")
  private String username;

  @Value("${frontend.password}")
  private String password;

  public LoginPage visit() {
    webDriver.get(ropsUrl);
    return this;
  }

  public void andLogin() {
    webDriver.findElement(By.id("exampleInputEmail1"))
      .sendKeys(username);
    webDriver.findElement(By.id("exampleInputPassword1"))
      .sendKeys(password);
    webDriver.findElement(By.id("submitId"))
      .click();
    
    assertTrue(webDriver.getCurrentUrl().endsWith("staff?"), "Unexpecteed page");
  }
}