package booking.frontend.pages;

import static org.junit.jupiter.api.Assertions.assertTrue;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.support.ui.Select;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;


@Component
public class StaffPage {

  @Autowired
  private WebDriver webDriver;

  public void clickAddModule() {
    webDriver.findElement(By.id("addModule")).click();
    
    assertTrue(webDriver.getCurrentUrl().endsWith("module"), "Unexpected page");
  }

  public void clickAddTutor() {
    webDriver.findElement(By.id("addTutor")).click();
    
    assertTrue(webDriver.getCurrentUrl().endsWith("staff/add"), "Unexpected page");
  }

  public void clickAssignModule() {
    webDriver.findElement(By.id("assignModule")).click();
    
    assertTrue(webDriver.getCurrentUrl().endsWith("module/tutors"), "Unexpected page");
  }

  public void click(String id) {
    webDriver.findElement(By.id(id)).click();
  }

  public StaffPage inputText(String id, String message) {
    webDriver.findElement(By.id(id)).sendKeys(message);
    return this;
  }

  public StaffPage selectOption(String id, String option) {
    new Select(webDriver.findElement(By.id(id)))
      .selectByVisibleText(option);
    return this;
  }
}
