package booking.frontend.pages;

import java.io.IOException;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.support.ui.Select;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;
import org.springframework.stereotype.Component;

@Component
public class StudentPage {

  @Autowired
  private WebDriver webDriver;

  public void click(String id) {
    webDriver.findElement(By.id(id)).click();
  }

  public StudentPage inputText(String id, String message) {
    webDriver.findElement(By.id(id)).sendKeys(message);
    return this;
  }

  public StudentPage selectOption(String id, String option) {
    new Select(webDriver.findElement(By.id(id)))
      .selectByVisibleText(option);
    return this;
  }

  public StudentPage uploadFile() {
    Resource sampleFile = new ClassPathResource("testFile.txt");
    try {
      webDriver.findElement(By.id("customFile"))
        .sendKeys(sampleFile.getURI().getPath());
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
    webDriver.findElement(By.id("submit"))
      .click();
    return this;
  }
}